---
aliases:
- /doc/roadmap/
- /meta/roadmap/
lastmod: 2015-02-16
date: 2013-07-01
menu:
  main:
    parent: about
notoc: true
title: Hugo Roadmap
weight: 20
---

In no particular order, here is what we are working on:

 * Intelligently related posts ([#98][])
 * Even easier deployment to S3, SSH, GitHub, rsync. Give the [tools section](https://gohugo.io/tools/#deployment) a shot or read one of the related tutorials.
 * Import from other website systems. There are already existing [migration tools](https://gohugo.io/tools/#migration) but they don't cover all major platforms.
 * An interactive web based editor (See https://discuss.gohugo.io/t/web-based-editor/155)
 * Additional [themes](https://github.com/spf13/hugoThemes) (always on-going, contributions welcome!)
 * Dynamic image resizing via shortcodes ([#1014][])
 * Native support for additional content formats (AsciiDoc [#1435][], reST [#1436][])
 * And, last but not least, ***Your best ideas***!

[#100]: https://github.com/spf13/hugo/issues/100 "hugo import from wordpress · Issue #100 · spf13/hugo"
[#101]: https://github.com/spf13/hugo/issues/101 "hugo import from jekyll · Issue #101 · spf13/hugo"
[#1435]: https://github.com/spf13/hugo/issues/1435 "Add support for native Go implementation of AsciiDoc · Issue #1435 · spf13/hugo"
[#1436]: https://github.com/spf13/hugo/issues/1436 "Add support for native Go implementation of reStructuredText (reST) · Issue #1436 · spf13/hugo"
[#1014]: https://github.com/spf13/hugo/issues/1014 "Image Resizing and Cropping · Issue #1014 · spf13/hugo"
[#98]: https://github.com/spf13/hugo/issues/98 "Add support for related content · Issue #98 · spf13/hugo"

> Feel free to [contribute]({{< relref "tutorials/how-to-contribute-to-hugo.md" >}}) or open a [new issue](https://github.com/spf13/hugo/issues/new) if you have an idea for a new feature.)
